<?php
function gfci_custom_multi_register() {
	if ( !$options = get_option('custom_widget_gfci') )
		$options = array();
	$widget_ops = array('classname' => 'custom_widget_gfci', 'description' => __('Add a Google Friend Connect Custom Gadget'));
	$control_ops = array('width' => 420, 'height' => 420, 'id_base' => 'gfcicustom');
	$name = __('GFC Custom');

	$registered = false;
	foreach ( array_keys($options) as $o ) {
		// Old widgets can have null values for some reason
		if ( !isset($options[$o]['gadget_wid']) )
			continue;
		$id = "gfcicustom-$o"; // Never never never translate an id
		$registered = true;
		wp_register_sidebar_widget($id, $name, 'GFCIWidget_Custom', $widget_ops, array( 'number' => $o ));
		wp_register_widget_control($id, $name, 'widget_gfci_custom_control', $control_ops, array( 'number' => $o ));
	}
	
	// If there are none, we register the widget's existance with a generic template
	if ( !$registered ) {
            wp_register_sidebar_widget('gfcicustom-1', $name, 'GFCIWidget_Custom', $widget_ops, array( 'number' => -1 ) );
            wp_register_widget_control('gfcicustom-1', $name, 'widget_gfci_custom_control', $control_ops, array( 'number' => -1 ) );
        }
}

function GFCIWidget_Custom($args, $widget_args = 1) {
	extract( $args, EXTR_SKIP );
	if ( is_numeric($widget_args) )
		$widget_args = array( 'number' => $widget_args );
	$widget_args = wp_parse_args( $widget_args, array( 'number' => -1 ) );
	extract( $widget_args, EXTR_SKIP );
	$canvas_path = get_option( gfci_canvas_path );
	$options = get_option('custom_widget_gfci');
	if ( !isset($options[$number]) )
		return;
        $gadget_wid = attribute_escape($options[$number]['gadget_wid']);
	$gadget_hei = attribute_escape($options[$number]['gadget_hei']);
	$endcap_bkgd = attribute_escape($options[$number]['endcap_bkgd']);
	$endcap_text = attribute_escape($options[$number]['endcap_text']);
	$endcap_links = attribute_escape($options[$number]['endcap_links']);
	$content_bkgd = attribute_escape($options[$number]['content_bkgd']);
	$content_text = attribute_escape($options[$number]['content_text']);
	$content_text2 = attribute_escape($options[$number]['content_text2']);
	$content_links = attribute_escape($options[$number]['content_links']);
	$content_links2 = attribute_escape($options[$number]['content_links2']);
	$content_hlines = attribute_escape($options[$number]['content_hlines']);
	$alt_bkgd = attribute_escape($options[$number]['alt_bkgd']);
	$gfci_border = attribute_escape($options[$number]['gfci_border']);
	$header_text = attribute_escape($options[$number]['header_text']);

  echo $before_widget;
  echo $before_title;
  echo $after_title;
?>
<div id="gfccustom-<?php echo $number; ?>" style="width:<?php echo $gadget_wid; ?>px;border:1px solid #<?php echo $gfci_border ?>;"></div>
<script type="text/javascript">
var skin = {};
skin['BORDER_COLOR'] = '<?php echo $gfci_border; ?>';
skin['ENDCAP_BG_COLOR'] = '<?php echo $endcap_bkgd; ?>';
skin['ENDCAP_TEXT_COLOR'] = '<?php echo $endcap_text; ?>';
skin['ENDCAP_LINK_COLOR'] = '<?php echo $endcap_links; ?>';
skin['ALTERNATE_BG_COLOR'] = '<?php echo $alt_bkgd; ?>';
skin['CONTENT_BG_COLOR'] = '<?php echo $content_bkgd; ?>';
skin['CONTENT_LINK_COLOR'] = '<?php echo $content_links; ?>';
skin['CONTENT_TEXT_COLOR'] = '<?php echo $content_text; ?>';
skin['CONTENT_SECONDARY_LINK_COLOR'] = '<?php echo $content_links2; ?>';
skin['CONTENT_SECONDARY_TEXT_COLOR'] = '<?php echo $content_text2; ?>';
skin['CONTENT_HEADLINE_COLOR'] = '<?php echo $content_hlines; ?>';
google.friendconnect.container.setParentUrl('<?php echo $canvas_path; ?>' /* location of rpc_relay.html and canvas.html */);
google.friendconnect.container.renderOpenSocialGadget(
 { id: 'gfccustom-<?php echo $number; ?>',
   url:'<?php echo $gadget_hei; ?>',
   site: '<?php echo gfci_sit(); ?>'},
  skin);
</script>
<?php
  echo $after_widget;
}

function widget_gfci_custom_control($widget_args) {
	global $wp_registered_widgets;
	static $updated = false; // Whether or not we have already updated the data after a POST submit

	if ( is_numeric($widget_args) )
		$widget_args = array( 'number' => $widget_args );
	$widget_args = wp_parse_args( $widget_args, array( 'number' => -1 ) );
	extract( $widget_args, EXTR_SKIP );

	// Data should be stored as array:  array( number => data for that instance of the widget, ... )
	$options_all = get_option('custom_widget_gfci');
	if ( !is_array($options_all) )
		$options_all = array();

	if ( !$updated && !empty($_POST['sidebar']) ) {
		// Tells us what sidebar to put the data in
		$sidebar = (string) $_POST['sidebar'];

		$sidebars_widgets = wp_get_sidebars_widgets();
		if ( isset($sidebars_widgets[$sidebar]) )
			$this_sidebar =& $sidebars_widgets[$sidebar];
		else
			$this_sidebar = array();

		foreach ( $this_sidebar as $_widget_id ) {
		if ( 'custom_widget_gfci' == $wp_registered_widgets[$_widget_id]['callback'] && isset($wp_registered_widgets[$_widget_id]['params'][0]['number']) ) {
				$widget_number = $wp_registered_widgets[$_widget_id]['params'][0]['number'];
				if (!in_array("gfcicustom-$widget_number", $_POST['widget-id']))
				unset($options_all[$widget_number]);
			}
		}
                foreach ( (array) $_POST['gfc-custom-post'] as $widget_number => $posted ) {
			if (!isset($posted['gadget_wid']) && isset($options_all[$widget_number]))
                    continue;
                
                $options = array();
                $options['gadget_wid'] = $posted['gadget_wid'];
		$options['gadget_hei'] = $posted['gadget_hei'];
		$options['endcap_bkgd'] = $posted['endcap_bkgd'];
		$options['endcap_text'] = $posted['endcap_text'];
		$options['endcap_links'] = $posted['endcap_links'];
		$options['content_bkgd'] = $posted['content_bkgd'];
		$options['content_text'] = $posted['content_text'];
		$options['content_text2'] = $posted['content_text2'];
		$options['content_links'] = $posted['content_links'];
		$options['content_links2'] = $posted['content_links2'];
		$options['content_hlines'] = $posted['content_hlines'];
		$options['header_text'] = $posted['header_text'];
		$options['gfci_border'] = $posted['gfci_border'];
		$options_all[$widget_number] = $options;
            }
            update_option('custom_widget_gfci', $options_all);
            $updated = true;
	    
}
	if ( -1 == $number ) { // We echo out a template for a form which can be converted to a specific form later via JS
		$gadget_wid = '282';
		$number = '%i%';
		$gadget_hei = 'http://www.socialarrow.com/gadgets/whovisited.xml';
		$endcap_bkgd = 'e0ecff';
		$endcap_text = '333333';
		$endcap_links = '0000cc';
		$content_bkgd = 'ffffff';
		$content_text = '333333';
		$content_text2 = '666666';
		$content_links = '0000cc';
		$content_links2 = '7777cc';
		$content_hlines = '333333';
		$header_text = 'Comments';
		$gfci_border = 'cccccc';

	} else {
		$gadget_wid = $options_all[$number]['gadget_wid'];
		$gadget_hei = $options_all[$number]['gadget_hei'];
		$endcap_bkgd = $options_all[$number]['endcap_bkgd'];
		$endcap_text = $options_all[$number]['endcap_text'];
		$endcap_links = $options_all[$number]['endcap_links'];
		$content_bkgd = $options_all[$number]['content_bkgd'];
		$content_text = $options_all[$number]['content_text'];
		$content_text2 = $options_all[$number]['content_text2'];
		$content_links = $options_all[$number]['content_links'];
		$content_links2 = $options_all[$number]['content_links2'];
		$content_hlines = $options_all[$number]['content_hlines'];
		$header_text = $options_all[$number]['header_text'];
		$gfci_border = $options_all[$number]['gfci_border'];
	}

?>
<h3>Custom Gadget Width and Source</h3>
<table>
<tr>
<td><label for="<?php echo $number; ?>-gadget-wid">
  Width:
  </label></td>
<td><input class="widefat" 
    type="text"
    name="gfc-custom-post[<?php echo $number; ?>][gadget_wid]" 
    id="<?php echo $number; ?>-gadget-wid" 
    value="<?php echo $gadget_wid; ?>" /></td>
</tr>
<tr>
<td><label for="<?php echo $number; ?>-gadget-hei">
Gadget URL:
  </label></td>
<td colspan="2"><input class="widefat" type="text" 
    name="gfc-custom-post[<?php echo $number; ?>][gadget_hei]" 
    id="<?php echo $number; ?>-gadget-hei" 
    value="<?php echo $gadget_hei; ?>"
    size="40" /></td>
</tr>

  
  </table>
<h3>Custom Color Settings</h3>
<table>
<tr>
<td>
<table>
<tr><td>Format Example:</td><td><b>FFFFFF</b></td></tr>
<tr><td><label for="<?php echo $number; ?>-endcap-bkgd">
Endcap Bkgd:</label></td>
<td><input class="widefat"
    name="gfc-custom-post[<?php echo $number; ?>][endcap_bkgd]"
    type="text"
    id="<?php echo $number; ?>-endcap-bkgd"
    value="<?php echo $endcap_bkgd; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo $number; ?>-endcap-text">
Endcap Text:</label></td>
<td><input class="widefat"
    name="gfc-custom-post[<?php echo $number; ?>][endcap_text]"
    type="text"
    id="<?php echo $number; ?>-endcap-text"
    value="<?php echo $endcap_text; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo $number; ?>-endcap-links">
Endcap Links:</label></td>
<td><input class="widefat"
    name="gfc-custom-post[<?php echo $number; ?>][endcap_links]"
    type="text"
    id="<?php echo $number; ?>-endcap-links"
    value="<?php echo $endcap_links; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo $number; ?>-content-bkgd">
Content Bkgd:</label></td>
<td><input class="widefat"
    name="gfc-custom-post[<?php echo $number; ?>][content_bkgd]"
    type="text"
    id="<?php echo $number; ?>-content-bkgd"
    value="<?php echo $content_bkgd; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo $number; ?>-content-text">
Content Text:</label></td>
<td><input class="widefat"
    name="gfc-custom-post[<?php echo $number; ?>][content_text]"
    type="text"
    id="<?php echo $number; ?>-content-text"
    value="<?php echo $content_text; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo $number; ?>-content-text2">
Sec. Content Text:</label></td>
<td><input class="widefat"
    name="gfc-custom-post[<?php echo $number; ?>][content_text2]"
    type="text"
    id="<?php echo $number; ?>-content-text2"
    value="<?php echo $content_text2; ?>"
    size="7"/></td>
</tr>
</table>
</td>
<td>
<table>
<tr><td><label for="<?php echo $number; ?>-content-links">
Content Links:</label></td>
<td><input class="widefat"
    name="gfc-custom-post[<?php echo $number; ?>][content_links]"
    type="text"
    id="<?php echo $number; ?>-content-links"
    value="<?php echo $content_links; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo $number; ?>-content-links2">
Sec. Content Links:</label></td>
<td><input class="widefat"
    name="gfc-custom-post[<?php echo $number; ?>][content_links2]"
    type="text"
    id="<?php echo $number; ?>-content-links2"
    value="<?php echo $content_links2; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo $number; ?>-content-hlines">
Content Headlines:</label></td>
<td><input class="widefat"
    name="gfc-custom-post[<?php echo $number; ?>][content_hlines]"
    type="text"
    id="<?php echo $number; ?>-content-hlines"
    value="<?php echo $content_hlines; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo $number; ?>-alt-bkgd">
Alt. Background:</label></td>
<td><input class="widefat"
    name="gfc-custom-post[<?php echo $number; ?>][alt_bkgd]"
    type="text"
    id="<?php echo $number; ?>-alt-bkgd"
    value="<?php echo $alt_bkgd; ?>"
    size="7"/></td>
</tr>
<tr><td><label for="<?php echo $number; ?>-gfci-border">
Border:</label></td>
<td><input class="widefat"
    name="gfc-custom-post[<?php echo $number; ?>][gfci_border]"
    type="text"
    id="<?php echo $number; ?>-gfci-border"
    value="<?php echo $gfci_border; ?>"
    size="7"/></td>
    <td><input type="hidden" id="gfc-custom-submit-<?php echo $number; ?>" name="gfc-custom-submit-<?php echo $number; ?>" value="1" /></td>
</tr>
</table></td></tr></table>
<?php
}
?>
